Index: /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 230)
+++ /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 231)
@@ -51,4 +51,73 @@
 #endif
 
+#if MERL_VSP_C0152
+
+#define CHECK_ADD_YET(pcCURef,uiIdx,vspIdx) && !( (pcCURef)->getVSPIndex(uiIdx) == vspIdx && bVspMvZeroDone[vspIdx-1] )
+
+inline Void TComDataCU::xInheritVspMode( TComDataCU* pcCURef, UInt uiIdx, Bool* bVspMvZeroDone, Int iCount, Int* iVSPIndexTrue, TComMvField* pcMvFieldNeighbours, DisInfo* pDInfo )
+{
+  Int vspIdx = (Int) pcCURef->getVSPIndex(uiIdx);
+  if( vspIdx != 0 )
+  {
+    Int idx = vspIdx - 1;
+    bVspMvZeroDone[idx] = true;
+    iVSPIndexTrue [idx] = iCount;
+
+    // no need to reset Inter Dir
+
+    // set MV using checked disparity
+    if (vspIdx < 4)
+    {
+      pcMvFieldNeighbours[ iCount<<1].setMvField ( pDInfo->m_acMvCand[0],  NOT_VALID );
+      if ( pcCURef->getSlice()->isInterB() )
+      {
+         pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField ( pDInfo->m_acMvCand[0],  NOT_VALID );
+      }
+    }
+  }
+}
+
+inline Bool TComDataCU::xAddVspMergeCand( UChar ucVspMergePos, Int vspIdx, Bool* bVspMvZeroDone, UInt uiDepth, Bool* abCandIsInter, Int& iCount,
+                                          UChar* puhInterDirNeighbours, TComMvField* pcMvFieldNeighbours, Int* iVSPIndexTrue, Int mrgCandIdx, DisInfo* pDInfo )
+{
+  if( ucVspMergePos == VSP_MERGE_POS )
+  {
+    Int idx = vspIdx - 1;
+    {
+      if( getSlice()->getSPS()->getViewId() != 0 && bVspMvZeroDone[idx] == false )
+      {
+        {
+          abCandIsInter [iCount] = true;
+          bVspMvZeroDone[idx] = true;
+
+          // get Inter Dir
+          Int iInterDir = ((getSlice()->getNumRefIdx(REF_PIC_LIST_0) > 0 && getSlice()->getNumRefIdx(REF_PIC_LIST_1) > 0) ? 3 :
+            (getSlice()->getNumRefIdx(REF_PIC_LIST_0) > 0 ? 1 : 2));
+          puhInterDirNeighbours[iCount] = iInterDir; // The direction information does not matter
+          // get Mv using checked disparity vector
+          if (vspIdx < 4) // spatial
+          {
+            pcMvFieldNeighbours[iCount<<1].setMvField(pDInfo->m_acMvCand[0], NOT_VALID );
+            if ( getSlice()->isInterB() )
+            {
+              pcMvFieldNeighbours[(iCount<<1)+1].setMvField( pDInfo->m_acMvCand[0], NOT_VALID );
+            }
+          }
+          iVSPIndexTrue[idx] = iCount;
+#if SIMP_MRG_PRUN
+          if ( mrgCandIdx == iCount )
+          {
+            return false;
+          }
+#endif
+          iCount ++;
+        }
+      }
+    }
+  }
+  return true;
+}
+#endif
+
 // ====================================================================================================================
 // Constructor / destructor / create / destroy
@@ -79,4 +148,7 @@
 #endif
   m_puhMergeIndex      = NULL;
+#if MERL_VSP_C0152
+  m_piVSPIndex         = NULL;
+#endif
   m_puhLumaIntraDir    = NULL;
   m_puhChromaIntraDir  = NULL;
@@ -213,4 +285,7 @@
 #endif
     m_puhMergeIndex      = (UChar* )xMalloc(UChar,  uiNumPartition);
+#if MERL_VSP_C0152
+    m_piVSPIndex         = (Char*  )xMalloc(Char,   uiNumPartition);
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
     m_pbResPredAvailable = (Bool*  )xMalloc(Bool,   uiNumPartition);
@@ -364,4 +439,7 @@
     if ( m_pbICFlag           ) { xFree(m_pbICFlag);            m_pbICFlag          = NULL; }
 #endif
+#if MERL_VSP_C0152
+    if ( m_piVSPIndex         ) { xFree(m_piVSPIndex);          m_piVSPIndex        = NULL; }
+#endif
     if ( m_puhMergeIndex      ) { xFree(m_puhMergeIndex);       m_puhMergeIndex     = NULL; }
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -558,4 +636,7 @@
 #endif
     m_puhMergeIndex[ui]=pcFrom->m_puhMergeIndex[ui];
+#if MERL_VSP_C0152
+    m_piVSPIndex[ui] = pcFrom->m_piVSPIndex[ui];
+#endif
     m_puhLumaIntraDir[ui]=pcFrom->m_puhLumaIntraDir[ui];
     m_puhChromaIntraDir[ui]=pcFrom->m_puhChromaIntraDir[ui];
@@ -598,4 +679,7 @@
 #endif
     memset( m_puhMergeIndex     + firstElement, 0,                        numElements * sizeof( *m_puhMergeIndex ) );
+#if MERL_VSP_C0152
+    memset( m_piVSPIndex        + firstElement, 0,                        numElements * sizeof( *m_piVSPIndex ) );
+#endif
     memset( m_puhLumaIntraDir   + firstElement, 2,                        numElements * sizeof( *m_puhLumaIntraDir ) );
     memset( m_puhChromaIntraDir + firstElement, 0,                        numElements * sizeof( *m_puhChromaIntraDir ) );
@@ -781,4 +865,7 @@
 #endif
       m_puhMergeIndex[ui] = 0;
+#if MERL_VSP_C0152
+      m_piVSPIndex[ui] = 0;
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
       m_pbResPredAvailable[ui] = 0;
@@ -876,4 +963,7 @@
   Int iSizeInUchar = sizeof( UChar  ) * m_uiNumPartition;
   Int iSizeInBool  = sizeof( Bool   ) * m_uiNumPartition;
+#if MERL_VSP_C0152
+  Int iSizeInChar  = sizeof( Char   ) * m_uiNumPartition;
+#endif
 
 #if H0736_AVC_STYLE_QP_RANGE
@@ -893,4 +983,7 @@
 #endif
   memset( m_puhMergeIndex,      0, iSizeInUchar );
+#if MERL_VSP_C0152
+  memset( m_piVSPIndex,         0, iSizeInChar );
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   memset( m_pbResPredAvailable, 0, iSizeInBool  );
@@ -973,4 +1066,7 @@
 #endif
       m_puhMergeIndex[ui]=pcCU->m_puhMergeIndex[uiPartOffset+ui];
+#if MERL_VSP_C0152
+      m_piVSPIndex[ui]=pcCU->m_piVSPIndex[uiPartOffset+ui];
+#endif
       m_puhLumaIntraDir[ui]=pcCU->m_puhLumaIntraDir[uiPartOffset+ui];
       m_puhChromaIntraDir[ui]=pcCU->m_puhChromaIntraDir[uiPartOffset+ui];
@@ -1117,4 +1213,7 @@
 #endif
   m_puhMergeIndex       = pcCU->getMergeIndex()       + uiPart;
+#if MERL_VSP_C0152
+  m_piVSPIndex          = pcCU->getVSPIndex()         + uiPart;
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   m_pbResPredAvailable  = pcCU->getResPredAvail()     + uiPart;
@@ -1227,5 +1326,5 @@
   m_uiCUAddr           = pcCU->getAddr();
   m_uiAbsIdxInLCU      = uiAbsPartIdx;
-  
+
   Int iRastPartIdx     = g_auiZscanToRaster[uiAbsPartIdx];
   m_uiCUPelX           = pcCU->getCUPelX() + m_pcPic->getMinCUWidth ()*( iRastPartIdx % m_pcPic->getNumPartInWidth() );
@@ -1257,4 +1356,7 @@
 #endif
   m_puhMergeIndex      = pcCU->getMergeIndex()            + uiAbsPartIdx;
+#if MERL_VSP_C0152
+  m_piVSPIndex         = pcCU->getVSPIndex()              + uiAbsPartIdx;
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   m_pbResPredAvailable = pcCU->getResPredAvail()          + uiAbsPartIdx;
@@ -1288,4 +1390,7 @@
   Int iSizeInUchar  = sizeof( UChar ) * uiNumPartition;
   Int iSizeInBool   = sizeof( Bool  ) * uiNumPartition;
+#if MERL_VSP_C0152
+  Int iSizeInChar   = sizeof( Char )  * uiNumPartition;
+#endif
   
 #if H0736_AVC_STYLE_QP_RANGE
@@ -1306,4 +1411,7 @@
 #endif
   memcpy( m_puhMergeIndex       + uiOffset, pcCU->getMergeIndex(),        iSizeInUchar );
+#if MERL_VSP_C0152
+  memcpy( m_piVSPIndex          + uiOffset, pcCU->getVSPIndex(),          iSizeInChar );
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   memcpy( m_pbResPredAvailable  + uiOffset, pcCU->getResPredAvail(),      iSizeInBool  );
@@ -1419,4 +1527,7 @@
   Int iSizeInUchar  = sizeof( UChar ) * m_uiNumPartition;
   Int iSizeInBool   = sizeof( Bool  ) * m_uiNumPartition;
+#if MERL_VSP_C0152
+  Int iSizeInChar   = sizeof( Char  ) * m_uiNumPartition;
+#endif
   
 #if H0736_AVC_STYLE_QP_RANGE
@@ -1440,4 +1551,7 @@
 #endif
   memcpy( rpcCU->getMergeIndex()        + m_uiAbsIdxInLCU, m_puhMergeIndex,       iSizeInUchar );
+#if MERL_VSP_C0152
+  memcpy( rpcCU->getVSPIndex()          + m_uiAbsIdxInLCU, m_piVSPIndex,         iSizeInChar );
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   memcpy( rpcCU->getResPredAvail()      + m_uiAbsIdxInLCU, m_pbResPredAvailable,  iSizeInBool  );
@@ -1547,4 +1661,7 @@
   Int iSizeInUchar  = sizeof( UChar  ) * uiQNumPart;
   Int iSizeInBool   = sizeof( Bool   ) * uiQNumPart;
+#if MERL_VSP_C0152
+  Int iSizeInChar   = sizeof( Char   ) * uiQNumPart;
+#endif
   
 #if H0736_AVC_STYLE_QP_RANGE
@@ -1566,4 +1683,7 @@
 #endif
   memcpy( rpcCU->getMergeIndex()        + uiPartOffset, m_puhMergeIndex,       iSizeInUchar );
+#if MERL_VSP_C0152
+  memcpy( rpcCU->getVSPIndex()          + uiPartOffset, m_piVSPIndex,         iSizeInChar );
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   memcpy( rpcCU->getResPredAvail()      + uiPartOffset, m_pbResPredAvailable,  iSizeInBool  );
@@ -3033,4 +3153,11 @@
 }
 
+#if MERL_VSP_C0152
+Void TComDataCU::setVSPIndexSubParts ( Char iVSPIdx, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
+{
+  setSubPart<Char>( iVSPIdx, m_piVSPIndex, uiAbsPartIdx, uiDepth, uiPartIdx );
+}
+#endif
+
 #if HHI_INTER_VIEW_RESIDUAL_PRED
 Void TComDataCU::setResPredAvailSubParts( Bool bResPredAvailable, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
@@ -3084,7 +3211,5 @@
 
       if((getInterDir(uiPartAddr) & (uiRefIdx+1)) && iBestRefIdx >= 0 && getSlice()->getViewId() != getSlice()->getRefViewId(eRefList, iBestRefIdx))
-      {
         return true;
-      }
     }
   }
@@ -3618,5 +3743,9 @@
  */
 #if SIMP_MRG_PRUN
+#if MERL_VSP_C0152
+Void TComDataCU::getInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int* iVSPIndexTrue, Int mrgCandIdx )
+#else
 Void TComDataCU::getInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int mrgCandIdx )
+#endif
 #else
 Void TComDataCU::getInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand )
@@ -3645,4 +3774,8 @@
 #endif
 
+#if MERL_VSP_C0152
+  Bool bVspMvZeroDone[3] = {false, false, false};
+#endif
+  
   Int iCount = 0;
 
@@ -3687,6 +3820,8 @@
     getDisMvpCand2(uiPUIdx, uiAbsPartIdx, &cDisInfo
 #if LGE_IVMP_PARALLEL_MERGE_B0136==QC_SIMPLE_NBDV_B0047
-,
-true
+            , true
+#endif
+#if MERL_VSP_C0152
+            , true
 #endif
 );
@@ -3714,4 +3849,5 @@
   Int     iPdmInterDir      = getPdmMergeCandidate( uiPUIdx, aiPdmRefIdx, acPdmMv );
 #endif
+
 #if QC_MRG_CANS_B0048
   if( iPdmDir[0] && !bNoPdmMerge && PDM_MERGE_POS == 0 )
@@ -3785,4 +3921,12 @@
   }
 #endif
+
+#if MERL_VSP_COMPENSATION_C0152
+  //===== vsp 0 ===== 
+  if( iCount < 4 + extraMergeCand )
+    if ( !xAddVspMergeCand(0, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+      return;
+#endif
+
   //left
   UInt uiLeftPartIdx = 0;
@@ -3805,5 +3949,9 @@
   if (!(uiPUIdx == 1 && (partSize == SIZE_Nx2N || partSize == SIZE_nLx2N || partSize == SIZE_nRx2N)))
   {
-  if ( pcCULeft && !pcCULeft->isIntra( uiLeftPartIdx ) )
+  if ( pcCULeft && !pcCULeft->isIntra( uiLeftPartIdx )
+#if MERL_VSP_C0152
+     CHECK_ADD_YET(pcCULeft, uiLeftPartIdx, 1)
+#endif
+  )
   {
     abCandIsInter[iCount] = true;
@@ -3852,4 +4000,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if MERL_VSP_C0152
+     xInheritVspMode( pcCULeft, uiLeftPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo ) ;
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -3902,4 +4053,11 @@
     iCount ++;
   }
+#endif
+
+#if MERL_VSP_COMPENSATION_C0152
+  //===== vsp 1 =====
+  if( iCount < 4 + extraMergeCand )
+    if ( !xAddVspMergeCand(1, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+      return;
 #endif
 
@@ -3928,4 +4086,7 @@
 #if SIMP_MRG_PRUN
   if ( pcCUAbove && !pcCUAbove->isIntra( uiAbovePartIdx ) 
+#if MERL_VSP_C0152
+    CHECK_ADD_YET(pcCUAbove, uiAbovePartIdx, 1)
+#endif
     && !(uiPUIdx == 1 && (cCurPS == SIZE_2NxN || cCurPS == SIZE_2NxnU || cCurPS == SIZE_2NxnD))
     && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCUAbove, uiAbovePartIdx ) ) )
@@ -3978,4 +4139,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if MERL_VSP_C0152
+     xInheritVspMode( pcCUAbove, uiAbovePartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo ) ;
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -4030,4 +4194,11 @@
     iCount ++;
   }
+#endif
+
+#if MERL_VSP_COMPENSATION_C0152
+  //===== vsp 2 =====
+  if( iCount < 4 + extraMergeCand )
+    if ( !xAddVspMergeCand(2, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+      return;
 #endif
 
@@ -4050,5 +4221,9 @@
 #endif
 #if SIMP_MRG_PRUN
-  if ( pcCUAboveRight && !pcCUAboveRight->isIntra( uiAboveRightPartIdx ) && ( !pcCUAbove || pcCUAbove->isIntra( uiAbovePartIdx ) || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveRight, uiAboveRightPartIdx ) ) )
+  if ( pcCUAboveRight && !pcCUAboveRight->isIntra( uiAboveRightPartIdx ) 
+#if MERL_VSP_C0152
+    CHECK_ADD_YET(pcCUAboveRight, uiAboveRightPartIdx, 1)
+#endif
+    && ( !pcCUAbove || pcCUAbove->isIntra( uiAbovePartIdx ) || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveRight, uiAboveRightPartIdx ) ) )
 #else
   if ( pcCUAboveRight && !pcCUAboveRight->isIntra( uiAboveRightPartIdx ) )
@@ -4074,4 +4249,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if MERL_VSP_C0152
+    xInheritVspMode( pcCUAboveRight, uiAboveRightPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo ) ;
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -4128,5 +4306,5 @@
     {
       assert(iCount < MRG_MAX_NUM_CANDS_MEM);
-      Bool bRemoveSpa = false; //prunign to A1, B1
+      Bool bRemoveSpa = false; //pruning to A1, B1
       abCandIsInter        [ iCount ] = true;
       puhInterDirNeighbours[ iCount ] = iPdmDir[1];
@@ -4173,4 +4351,22 @@
   }
 #endif
+#if MERL_VSP_COMPENSATION_C0152
+  //===== vsp 3 =====
+  if( iCount < 4 + extraMergeCand )
+    if ( !xAddVspMergeCand(3, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+      return;
+#endif
+
+#if MERL_VSP_C0152
+#if VSP_MERGE_POS < 4
+#if HHI_INTER_VIEW_MOTION_PRED
+  if( iCount < 4 + extraMergeCand )
+#else
+  if( iCount < 4 )
+#endif
+  {
+#endif
+#endif
+
   //left bottom
   UInt uiLeftBottomPartIdx = 0;
@@ -4191,5 +4387,9 @@
 #endif
 #if SIMP_MRG_PRUN
-  if ( pcCULeftBottom && !pcCULeftBottom->isIntra( uiLeftBottomPartIdx ) && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCULeftBottom, uiLeftBottomPartIdx ) ) )
+  if ( pcCULeftBottom && !pcCULeftBottom->isIntra( uiLeftBottomPartIdx ) 
+#if MERL_VSP_C0152
+    CHECK_ADD_YET(pcCULeftBottom, uiLeftBottomPartIdx, 1)
+#endif
+    && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCULeftBottom, uiLeftBottomPartIdx ) ) )
 #else
   if ( pcCULeftBottom && !pcCULeftBottom->isIntra( uiLeftBottomPartIdx ) )
@@ -4215,4 +4415,7 @@
     pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if MERL_VSP_C0152
+     xInheritVspMode( pcCULeftBottom, uiLeftBottomPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo ) ;
+#endif
 #if SIMP_MRG_PRUN
     if ( mrgCandIdx == iCount )
@@ -4223,5 +4426,10 @@
     iCount ++;
   }
-
+#if MERL_VSP_C0152
+#if VSP_MERGE_POS < 4
+  }
+#endif
+#endif
+  
 #if HHI_INTER_VIEW_MOTION_PRED
 #if QC_MRG_CANS_B0048
@@ -4263,5 +4471,12 @@
 #endif
 
-  // above left 
+#if MERL_VSP_COMPENSATION_C0152
+  //===== vsp 4 =====
+  if( iCount < 4 + extraMergeCand )
+    if ( !xAddVspMergeCand(4, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+      return;
+#endif
+  
+  // above left
 #if HHI_INTER_VIEW_MOTION_PRED
   if( iCount < 4 + extraMergeCand )
@@ -4288,4 +4503,7 @@
 #if SIMP_MRG_PRUN
     if( pcCUAboveLeft && !pcCUAboveLeft->isIntra( uiAboveLeftPartIdx )
+#if MERL_VSP_C0152
+     CHECK_ADD_YET(pcCUAboveLeft, uiAboveLeftPartIdx, 1)
+#endif
      && ( !pcCULeft || pcCULeft->isIntra( uiLeftPartIdx ) || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCUAboveLeft, uiAboveLeftPartIdx ) )
      && ( !pcCUAbove || pcCUAbove->isIntra( uiAbovePartIdx ) || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveLeft, uiAboveLeftPartIdx ) )
@@ -4314,4 +4532,7 @@
       pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
 #endif
+#if MERL_VSP_C0152
+     xInheritVspMode( pcCUAboveLeft, uiAboveLeftPartIdx, bVspMvZeroDone, iCount, iVSPIndexTrue, pcMvFieldNeighbours, &cDisInfo ) ;
+#endif
 #if SIMP_MRG_PRUN
       if ( mrgCandIdx == iCount )
@@ -4323,4 +4544,11 @@
     }
   }
+
+#if MERL_VSP_COMPENSATION_C0152
+  //===== vsp 5 =====
+  if( iCount < 4 + extraMergeCand )
+    if ( !xAddVspMergeCand(5, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
+      return;
+#endif
 
   if ( getSlice()->getPPS()->getEnableTMVPFlag() 
@@ -4356,4 +4584,12 @@
     Int uiLCUIdx = getAddr();
     PartSize eCUMode = getPartitionSize( 0 );
+
+#if MERL_VSP_C0152 // Potential bug, not related to BW_VSP
+    if (eCUMode==SIZE_NxN)
+    {
+      printf("Size NxN ???");
+      assert(0);
+    }
+#endif
 
     deriveRightBottomIdx( eCUMode, uiPUIdx, uiPartIdxRB );  
@@ -4598,5 +4834,14 @@
     {
       Int i = uiPriorityList0[idx]; Int j = uiPriorityList1[idx];
-      if (abCandIsInter[i] && abCandIsInter[j]&& (puhInterDirNeighbours[i]&0x1)&&(puhInterDirNeighbours[j]&0x2))
+#if MERL_VSP_C0152
+      Bool bValid = true;
+      if (pcMvFieldNeighbours[i<<1].getRefIdx() < 0 || pcMvFieldNeighbours[(j<<1)+1].getRefIdx() < 0) // NOT_VALID
+        bValid = false;
+#endif
+      if (abCandIsInter[i] && abCandIsInter[j]&& (puhInterDirNeighbours[i]&0x1)&&(puhInterDirNeighbours[j]&0x2)
+#if MERL_VSP_C0152
+       && bValid
+#endif
+         )
       {
         abCandIsInter[uiArrayAddr] = true;
@@ -4770,5 +5015,9 @@
   if( uiIter == 0 )
   {
-    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) )
+    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) 
+#if MERL_VSP_C0152
+     && !pcCorner->getVSPIndex( uiCornerPUIdx )
+#endif
+    )
     {
       rbValidCand = true;
@@ -4805,5 +5054,9 @@
   else
   {
-    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) )
+    if( pcCorner && !pcCorner->isIntra( uiCornerPUIdx ) 
+#if MERL_VSP_C0152
+     && !pcCorner->getVSPIndex( uiCornerPUIdx )
+#endif
+    )
     {
       rbValidCand = true;
@@ -4954,4 +5207,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
+#if MERL_VSP_C0152
+  if(! pcTmpCU->getVSPIndex(uiIdx))
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -4980,4 +5236,7 @@
 
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if MERL_VSP_C0152
+  if(! pcTmpCU->getVSPIndex(uiIdx))
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -5006,4 +5265,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
+#if MERL_VSP_C0152
+  if(! pcTmpCU->getVSPIndex(uiIdx))
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -5031,4 +5293,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if MERL_VSP_C0152
+  if(! pcTmpCU->getVSPIndex(uiIdx))
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -5059,4 +5324,7 @@
 #endif
   if(pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ))
+#if MERL_VSP_C0152
+  if(! pcTmpCU->getVSPIndex(uiIdx))
+#endif
   {
     for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
@@ -5257,4 +5525,56 @@
 }
 
+#if MERL_VSP_C0152
+Pel TComDataCU::getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iWidth, Int iHeight, Int* aiShiftLUT, Int iShiftPrec)
+{
+  Int depStride =  pcBaseViewDepthPicYuv->getStride();
+
+  Int width  = pcBaseViewDepthPicYuv->getWidth();
+  Int height = pcBaseViewDepthPicYuv->getHeight();
+
+  Int depthPosX = Clip3(0,   width - iWidth  - 1,  iBlkX + (mv->getHor()>>2));
+  Int depthPosY = Clip3(0,   height- iHeight - 1,  iBlkY + (mv->getVer()>>2));
+
+  Pel *depth  = pcBaseViewDepthPicYuv->getLumaAddr() + depthPosX + depthPosY * depStride;
+  Pel  maxDepth = 0;
+
+  for (Int j = 0; j < iHeight; j++)
+  {
+    for (Int i = 0; i < iWidth; i++)
+    {
+      if (maxDepth < depth[i])
+        maxDepth = depth[i];
+    }
+    depth += depStride;
+  }
+
+  Int disparity = aiShiftLUT[ maxDepth ] << iShiftPrec;
+
+  return disparity;
+}
+
+Void TComDataCU::estimateDVFromDM(UInt uiPartIdx, TComPic* picDepth, UInt uiPartAddr, TComMv* cMvPred)
+{
+  if (picDepth)
+  {
+    UInt uiAbsPartAddrCurrCU = m_uiAbsIdxInLCU + uiPartAddr;
+    Int iWidth, iHeight;
+    getPartIndexAndSize( uiPartIdx, uiPartAddr, iWidth, iHeight ); // The modified value of uiPartAddr won't be used any more
+    
+    TComPicYuv* pcBaseViewDepthPicYuv = picDepth->getPicYuvRec();
+    Int iBlkX = ( getAddr() % picDepth->getFrameWidthInCU() ) * g_uiMaxCUWidth  + g_auiRasterToPelX[ g_auiZscanToRaster[ uiAbsPartAddrCurrCU ] ];
+    Int iBlkY = ( getAddr() / picDepth->getFrameWidthInCU() ) * g_uiMaxCUHeight + g_auiRasterToPelY[ g_auiZscanToRaster[ uiAbsPartAddrCurrCU ] ];
+    Int* aiShiftLUT;
+    Int  iShiftPrec;
+    getSlice()->getBWVSPLUTParam(aiShiftLUT, iShiftPrec);
+    
+    Pel x = getMcpFromDM( pcBaseViewDepthPicYuv, cMvPred, iBlkX, iBlkY, iWidth, iHeight, aiShiftLUT, iShiftPrec );
+
+    cMvPred->setHor(x);
+    clipMv(*cMvPred);
+  }
+}
+#endif
+
 #if LGE_DVMCP_A0126
 #if QC_SIMPLE_NBDV_B0047
@@ -5263,4 +5583,7 @@
                                 , Bool bParMerge
 #endif
+#if MERL_VSP_C0152
+                                , Bool bDepthRefine
+#endif
 #else
 Void TComDataCU::getDisMvpCand2( UInt uiPartIdx, UInt uiPartAddr,DisInfo* pDInfo, Bool bMerge, RefPicList eRefPicList0, Int iRefIdx0
@@ -5345,10 +5668,21 @@
       {
         Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId);
-        if (refViewIdx!= m_pcSlice->getViewId()) // DCP
+        if (refViewIdx != m_pcSlice->getViewId()) // DCP
         {
           TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
           clipMv(cMvPred);
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
           pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
           pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+#else
+          {
+            TComPic* picDepth = NULL;
+            picDepth = getSlice()->getRefPicBaseDepth();
+            if (picDepth && bDepthRefine)
+              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
+            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+          }
+#endif
           return;
         }
@@ -5364,4 +5698,19 @@
         }
       }
+#if MERL_VSP_C0152
+      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
+      {
+        TComPic* picDepth = NULL;
+        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
+        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
+        if (picDepth && bDepthRefine)
+          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
+        myMv.setVer(0);
+
+        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
+        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
+        return;
+      }
+#endif
     }
   }
@@ -5405,6 +5754,17 @@
           TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
           clipMv(cMvPred);
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
           pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
           pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+#else
+          {
+            TComPic* picDepth = NULL;
+            picDepth = getSlice()->getRefPicBaseDepth();
+            if (picDepth && bDepthRefine)
+              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
+            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+          }
+#endif
           return;
         }
@@ -5424,4 +5784,19 @@
         }
       }
+#if MERL_VSP_C0152
+      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
+      {
+        TComPic* picDepth = NULL;
+        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
+        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
+        if (picDepth && bDepthRefine)
+          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
+        myMv.setVer(0);
+
+        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
+        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
+        return;
+      }
+#endif
     }
   }
@@ -5459,6 +5834,17 @@
           TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
           clipMv(cMvPred);
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
           pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
           pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+#else
+          {
+            TComPic* picDepth = NULL;
+            picDepth = getSlice()->getRefPicBaseDepth();
+            if (picDepth && bDepthRefine)
+              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
+            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+          }
+#endif
           return;
         }
@@ -5478,4 +5864,19 @@
         }
       }
+#if MERL_VSP_C0152
+      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
+      {
+        TComPic* picDepth = NULL;
+        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
+        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
+        if (picDepth && bDepthRefine)
+          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
+        myMv.setVer(0);
+
+        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
+        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
+        return;
+      }
+#endif
     }
   }
@@ -5509,6 +5910,17 @@
           TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
           clipMv(cMvPred);
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
           pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
           pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+#else
+          {
+            TComPic* picDepth = NULL;
+            picDepth = getSlice()->getRefPicBaseDepth();
+            if (picDepth && bDepthRefine)
+              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
+            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+          }
+#endif
           return;
         }
@@ -5524,4 +5936,19 @@
         }
       }
+#if MERL_VSP_C0152
+      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
+      {
+        TComPic* picDepth = NULL;
+        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
+        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
+        if (picDepth && bDepthRefine)
+          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
+        myMv.setVer(0);
+
+        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
+        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
+        return;
+      }
+#endif
     }
   }
@@ -5561,6 +5988,17 @@
           TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
           clipMv(cMvPred);
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
           pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred; 
           pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+#else
+          {
+            TComPic* picDepth = NULL;
+            picDepth = getSlice()->getRefPicBaseDepth();
+            if (picDepth && bDepthRefine)
+              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
+            pDInfo->m_acMvCand[ pDInfo->iN] = cMvPred;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = refViewIdx;
+          }
+#endif
           return;
         }
@@ -5580,4 +6018,19 @@
         }
       }
+#if MERL_VSP_C0152
+      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
+      {
+        TComPic* picDepth = NULL;
+        TComMv myMv = pcTmpCU->getCUMvField( eRefPicList )->getMv( uiIdx );
+        picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
+        if (picDepth && bDepthRefine)
+          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &myMv);
+        myMv.setVer(0);
+
+        pDInfo->m_acMvCand[ pDInfo->iN] = myMv;
+        pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; // refViewIdx;
+        return;
+      }
+#endif
     }
   }
@@ -5810,6 +6263,18 @@
           {
             clipMv(cColMv);
-            pDInfo->m_acMvCand[pDInfo->iN] = cColMv;
-            pDInfo->m_aVIdxCan[pDInfo->iN++] = iTargetViewIdx;
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
+            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
+#else
+            {
+              TComPic* picDepth = NULL;
+              picDepth = getSlice()->getRefPicBaseDepth();
+              if (picDepth && bDepthRefine)
+                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
+
+              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
+              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
+            }
+#endif
             return ;
           }
@@ -5819,6 +6284,17 @@
         {
           clipMv(cColMv);
-          pDInfo->m_acMvCand[pDInfo->iN] = cColMv;
-          pDInfo->m_aVIdxCan[pDInfo->iN++] = iTargetViewIdx;
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
+            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
+#else
+            {
+              TComPic* picDepth = NULL;
+              picDepth = getSlice()->getRefPicBaseDepth();
+              if (picDepth && bDepthRefine)
+                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
+              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
+              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
+            }
+#endif
           return ;
         }
@@ -5828,6 +6304,17 @@
           {
             clipMv(cColMv);
-            pDInfo->m_acMvCand[pDInfo->iN] = cColMv;
-            pDInfo->m_aVIdxCan[pDInfo->iN++] = iTargetViewIdx;
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
+            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
+#else
+            {
+              TComPic* picDepth = NULL;
+              picDepth = getSlice()->getRefPicBaseDepth();
+              if (picDepth && bDepthRefine)
+                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
+              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
+              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
+            }
+#endif
             return ;
           }
@@ -5852,6 +6339,17 @@
           TComMv dv( aiDvMcpDvCand[iList][ i ], 0 );
           clipMv( dv );
-          pDInfo->m_acMvCand[ pDInfo->iN  ] = dv;
-          pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0; 
+#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
+          pDInfo->m_acMvCand[ pDInfo->iN] = dv;
+          pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0;
+#else
+          {
+            TComPic* picDepth = NULL;
+            picDepth = getSlice()->getRefPicBaseDepth();
+            if (picDepth && bDepthRefine)
+              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &dv);
+            pDInfo->m_acMvCand[ pDInfo->iN] = dv;
+            pDInfo->m_aVIdxCan[ pDInfo->iN++] = 0;
+          }
+#endif
           return;
         }
@@ -5863,4 +6361,5 @@
 }
 #endif
+
 #endif
 
